
import java.util.Date;
import java.util.TimeZone;

import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.ext.swing.SwingComboBox;
import javafx.ext.swing.SwingComboBoxItem;
import javafx.ext.swing.SwingLabel;
import javafx.scene.Scene;
import javafx.scene.text.Font;
import javafx.scene.text.Text;
import javafx.stage.Stage;
import javafx.util.StringLocalizer;

// XNvgt@Cƃ\[Xt@Cт
StringLocalizer.associate("resources/worldClock", "", "worldClock.fx");

// ss
var cities = [
    ##[NY]"New York",
    ##[PR]"Paris",
    ##[TK]"Tokyo"
];
 
// ^C][
var timezones = [
    TimeZone.getTimeZone("America/New_York"),
    TimeZone.getTimeZone("Europe/Paris"),
    TimeZone.getTimeZone("Asia/Tokyo")
];

// IڂύXAftHg^C][ύX
var selectedIndex: Integer = 0 on replace {
    TimeZone.setDefault(timezones[selectedIndex]);
}

// Ԃ\ϐ
var time = new Date();

// 1bƂɎԂXV邽߂̃^CC
Timeline {
    repeatCount: Timeline.INDEFINITE
    keyFrames: [
        KeyFrame {
            time: 0s
            action: function() {
                time = new Date();
            }
        },
        KeyFrame {
            time: 1s
        }
    ]
}.play();

Stage {
    title: ##"World Clock"
    scene: Scene {
        width: 380 height: 100
        content: [
            SwingLabel {
                translateX: 20 translateY: 13
                text: ##"City:"
            },
            SwingComboBox {
                translateX: 70 translateY: 7
                width: 250

                // IڂselectedIndexɑooCh
                selectedIndex:
                    bind selectedIndex with inverse
                    
                items: for (city in cities) {
                    SwingComboBoxItem {
                        text: city
                    }
                }
            },
            Text {
                font: Font {
                    size: 20
                }
                x: 20 y: 70

                // ԕ\
                content: bind ##"{%ta time} {%tx time} {%tl time}:{%tM time}:{%tS time} {%Tp time}"
            }
        ]

    }
}